#if !defined(AFX_SolarFRM_H__6B91848F_465C_11D2_9003_444553540000__INCLUDED_)
#define AFX_SolarFRM_H__6B91848F_465C_11D2_9003_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// SolarFrm.h : header file
//
#include "Planet.h"
enum	{MAX_BODIES = 10};

const double	G = 6.67259e-11;	// Newton * m^2 / kg^2
									// (All values are in m and kg)

/////////////////////////////////////////////////////////////////////////////
// CSolarFrm window

class CSolarFrm : public CFrameWnd
{
// Construction
public:
	CSolarFrm();

// Attributes
public:
	int		m_nBodyCount;
	Planet	m_Bodies[MAX_BODIES];		// The solar system

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSolarFrm)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
public:
	void RemoveBody(int num);
	BOOL m_bStopInit;
	BOOL m_bGoInit;
	double m_G;
	BOOL m_bIgnoreUp;
	CRect m_ControlRect;
	double m_TimeStep;
	double m_Time;
	BOOL m_bRunLoop;
	BOOL m_bDragging;
	CPoint m_CurPoint;
	CPoint m_DownPoint;

	CButton m_StopButton;
	CButton m_GoButton;
	CSliderCtrl	m_TimeStepSldr;
	CSliderCtrl	m_GravitySldr;
	CButton m_ControlGB;
	CButton m_TimeStepGB;
	CButton m_GravityGB;
	CStatusBar m_wndStatusBar;
	CBitmap m_Bitmap;
	CStatic m_G1LabelBitmap;
	CStatic m_G2LabelBitmap;
	CStatic m_G3LabelBitmap;
	CStatic m_TSLabelBitmap;

	void GetViewRect(LPRECT r);
	void OnGo();
	void OnStop();
	BOOL PeekAndPump();

	virtual ~CSolarFrm();

	// Generated message map functions
protected:
	//{{AFX_MSG(CSolarFrm)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHelpInstructions();
	afx_msg void OnHelpAbout();
	afx_msg void OnFileExit();
	afx_msg void OnUpdateControlGo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateControlStop(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SolarFRM_H__6B91848F_465C_11D2_9003_444553540000__INCLUDED_)
